/*
 * Created by SharpDevelop.
 * User: Lee, Dong-Liang  http://dllee.ktop.com.tw
 * Date: 2005/3/21
 * Time: 10:13 PM
 *
 * This is a test program for testing WMI objects in VB.NET in #Develop
 * 
 * Ref: http://www.vbforums.com/showpost.php?p=1465671&postcount=1
 * Ref: http://dobon.net/vb/dotnet/system/wmi_os.html
 */
using System;
using System.Management;
using System.Drawing;
using System.Windows.Forms;

namespace testScriptInCS
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button1;
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(336, 216);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 48);
			this.button1.TabIndex = 1;
			this.button1.Text = "Read Temperature";
			this.button1.Click += new System.EventHandler(this.Button1Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
						| System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(464, 400);
			this.label1.TabIndex = 0;
			this.label1.Text = "label1";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
			this.ClientSize = new System.Drawing.Size(480, 414);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.label1);
			this.Name = "MainForm";
			this.Text = "WMI C# testing http://dllee.ktop.com.tw";
			this.Load += new System.EventHandler(this.MainFormLoad);
			this.ResumeLayout(false);
		}
		#endregion
		void MainFormLoad(object sender, System.EventArgs e)
		{
			string strsearch=string.Format(@"Select * from Win32_Processor"); 
 			System.Management.ManagementObjectSearcher p_objSet=new ManagementObjectSearcher();
			p_objSet.Scope=new ManagementScope(@"root\cimv2");
			p_objSet.Query=new ObjectQuery(strsearch);
			
			if((p_objSet.Get().Count<1) || (p_objSet.Get()==null))
			{
				this.label1.Text="No Processor Information";
			}
			else
			{
				foreach(System.Management.ManagementObject objItem in p_objSet.Get())
				{
					this.label1.Text=
						string.Format("Address Width: {0}\n",objItem["AddressWidth"].ToString())
					+	string.Format("Architecture: {0}\n",objItem["Architecture"].ToString())
					+	string.Format("Availability: {0}\n",objItem["Availability"].ToString())
					+	string.Format("CPU Status: {0}\n",objItem["CpuStatus"].ToString())
					+	string.Format("Current Clock Speed: {0}\n",objItem["CurrentClockSpeed"].ToString())
					+	string.Format("Data Width: {0}\n",objItem["DataWidth"].ToString())
					+	string.Format("Description: {0}\n",objItem["Description"].ToString())
					+	string.Format("Device ID: {0}\n",objItem["DeviceID"].ToString())
					+	string.Format("External Clock: {0}\n",objItem["ExtClock"].ToString())
					+	string.Format("Family: {0}\n",objItem["Family"].ToString())
					+	string.Format("L2 Cache Size: {0}\n",objItem["L2CacheSize"].ToString())
					// +	string.Format("L2 Cache Speed: {0}\n",objItem["L2CacheSpeed"].ToString())
					+	string.Format("Level: {0}\n",objItem["Level"].ToString())
					+	string.Format("Load Percentage: {0}\n",objItem["LoadPercentage"].ToString())
					+	string.Format("Manufacturer: {0}\n",objItem["Manufacturer"].ToString())
					+	string.Format("Maximum Clock Speed: {0}\n",objItem["MaxClockSpeed"].ToString())
					+	string.Format("Name: {0}\n",objItem["Name"].ToString())
					// +	string.Format("PNP Device ID: {0}\n",objItem["PNPDeviceID"].ToString())
					+	string.Format("Processor ID: {0}\n",objItem["ProcessorId"].ToString())
					+	string.Format("Processor Type: {0}\n",objItem["ProcessorType"].ToString())
					+	string.Format("Revision: {0}\n",objItem["Revision"].ToString())
					+	string.Format("Role: {0}\n",objItem["Role"].ToString())
					+	string.Format("Socket Designation: {0}\n",objItem["SocketDesignation"].ToString())
					+	string.Format("Status Information: {0}\n",objItem["StatusInfo"].ToString())
					+	string.Format("Stepping: {0}\n",objItem["Stepping"].ToString())
					// +	string.Format("Unique Id: {0}\n",objItem["UniqueId"].ToString())
					+	string.Format("Upgrade Method: {0}\n",objItem["UpgradeMethod"].ToString())
					+	string.Format("Version: {0}\n",objItem["Version"].ToString());
					// +	string.Format("Voltage Caps: {0}\n",objItem["VoltageCaps"].ToString());
				}
			}
		}
		
		void Button1Click(object sender, System.EventArgs e)
		{
			string strsearch=string.Format(@"Select * from MSAcpi_ThermalZoneTemperature"); 
 			System.Management.ManagementObjectSearcher p_objSet=new ManagementObjectSearcher();
			p_objSet.Scope=new ManagementScope(@"root\wmi");
			p_objSet.Query=new ObjectQuery(strsearch);
			
			if((p_objSet.Get().Count<1) || (p_objSet.Get()==null))
			{
				this.label1.Text="Temperature Information";
			}
			else
			{
				foreach(System.Management.ManagementObject objItem in p_objSet.Get())
				{
					int RawData=Convert.ToInt32(objItem["CurrentTemperature"]);
					this.label1.Text=
						string.Format("CurrentTemperature(RawData): {0}\n",RawData)
					+	string.Format("Temperature(C):              {0}\n",(RawData-2732)/10);
				}
			}
		}
		
	}
}
